﻿package
{ 
	import flash.display.Sprite;
	import flash.display.Shape;	

	public class Canvas extends Sprite
	{
		//variables
		private var pixelArr:Array;
		private var border:Shape;
		public var dimX:uint;
		public var dimY:uint;
		
		public function Canvas($x:uint, $y:uint)
		{		
			dimX = $x;
			dimY = $y;
		
			border = new Shape();
			border.graphics.lineStyle(3);
			border.graphics.drawRect(-$x*Constants.PIXDIM_CANVAS/2, -$y*Constants.PIXDIM_CANVAS/2, $x*Constants.PIXDIM_CANVAS, $y*Constants.PIXDIM_CANVAS);
			addChild(border);
		
			pixelArr = [];
		    for(var xx:uint=0; xx<$x; xx++){
				pixelArr[xx] = [];
				for(var yy:uint=0; yy<$y; yy++){
					pixelArr[xx][yy] = new EmptyPixel(this);
					pixelArr[xx][yy].x = -$x*Constants.PIXDIM_CANVAS/2+xx*Constants.PIXDIM_CANVAS;
					pixelArr[xx][yy].y = -$y*Constants.PIXDIM_CANVAS/2+yy*Constants.PIXDIM_CANVAS;		
					addChild(pixelArr[xx][yy]);
					//pixelArr[xx][yy].addChild(new Square(0xFFFFFF));
				}
			}
		}
		
		public function trim():void
		{
			var minX:uint = dimX;
			var maxX:uint = 0;
			var minY:uint = dimY;
			var maxY:uint = 0;
			
			var xx:uint;
			var yy:uint;
			for(xx=0; xx<dimX; xx++){
				for(yy=0; yy<dimY; yy++){
					if(pixelArr[xx][yy].col != Constants.COLEMPTYPIXEL){
						if(xx<minX) minX=xx;
						if(xx>maxX) maxX=xx;
						if(yy<minY) minY=yy;
						if(yy>maxY) maxY=yy;
					}
				}
			}
			
			if(maxX>=minX && maxY>=minY){
				dimX = maxX-minX+1;
				dimY = maxY-minY+1;
				var newPixArr:Array = [];
				for(xx=0; xx<dimX; xx++){
					newPixArr[xx] = [];
					for(yy=0; yy<dimY; yy++){
						newPixArr[xx][yy] = pixelArr[xx+minX][yy+minY];
					}
				}
				pixelArr = newPixArr;
			}
			else{
				dimX = dimY = 0;
				pixelArr = [];
			}
			
		}
		
		public function pixToString():String
		{
			var outStr:String;
			outStr = String(dimX) + "#" + String(dimY) + "#" ;
			
			for(var yy:uint=0; yy<dimY; yy++){
				for(var xx:uint=0; xx<dimX; xx++){
					switch (pixelArr[xx][yy].col) {
						case Constants.COL1: outStr+="1"; break;
						case Constants.COL2: outStr+="2"; break;
						case Constants.COL3: outStr+="3"; break;
						case Constants.COL4: outStr+="4"; break;
						case Constants.COL5: outStr+="5"; break;
						case Constants.COL6: outStr+="6"; break;
						case Constants.COL7: outStr+="7"; break;
						case Constants.COL8: outStr+="8"; break;
					}
				}
			}
					return outStr;
		}
		
		public function loadStr($str:String):void
		{
			for(var yy:uint=0; yy<dimY; yy++){
				for(var xx:uint=0; xx<dimX; xx++){
					switch($str.charAt(0)) {
						case "1": pixelArr[xx][yy].col = Constants.COL1; break;
						case "2": pixelArr[xx][yy].col = Constants.COL2; break;
						case "3": pixelArr[xx][yy].col = Constants.COL3; break;
						case "4": pixelArr[xx][yy].col = Constants.COL4; break;
						case "5": pixelArr[xx][yy].col = Constants.COL5; break;
						case "6": pixelArr[xx][yy].col = Constants.COL6; break;
						case "7": pixelArr[xx][yy].col = Constants.COL7; break;
						case "8": pixelArr[xx][yy].col = Constants.COL8; break;
					}
					$str = $str.substr(1);
				}
			}
					
						
		}
		
		/*
		public function setColor($col:uint, $x:uint, $y:uint){
			
		}
		*/
	}
}