﻿//****Main.as****

package
{ 
	import flash.display.*;
	import flash.events.MouseEvent;
	import flash.text.TextField;
	import flash.media.*;
	import flash.net.URLRequest;

	public class Main extends MovieClip
	{
		//variables
		private var canvas:Canvas;
		//private var palette:Palette;
		private var palMkr:PaletteMarker;
		private var palMkrPhantom:PaletteMarker;
		private var squarePhantom:Square;
		private var hider:Sprite;
		private var col:uint;
		
		private var armsLeft:Array;
		private var armsRight:Array;		
		private var legs:Array;
		private var head:Object;
		private var body:Object;
		private var allBodyParts:Array;
		private var totBodyParts:uint;
		private var bodyScaleX:Number;
		private var bodyScaleY:Number;		
		
		private var currBodyPart:Object;
		private var currPopup:MovieClip;
		private var mainSongChannel:SoundChannel;
		private var mainSongSound:Sound;
		private var cryptidRevealChannel:SoundChannel;
		private var cryptidRevealSound:Sound;
		private var tweetSound:Sound;
		//private var soundTrans_mute:SoundTransform;
		//private var soundTrans_fullVol:SoundTransform;
		
		public function Main()
		{				
			
			//soundTrans_mute = new SoundTransform();
			//soundTrans_fullVol = new SoundTransform();
			//soundTrans_mute.volume = 0;
			//soundTrans_fullVol.volume = 1;
			
			mainSongSound = new Sound();
			cryptidRevealSound = new Sound();
			tweetSound = new Tweet();
			
			mainSongSound.load(new URLRequest("./cryptidiaSong.mp3"));		
			cryptidRevealSound.load(new URLRequest("./cryptidReveal.mp3"));	
			
			mainSongChannel = mainSongSound.play(0,int.MAX_VALUE);
			
			palMkr = new PaletteMarker();
			palMkr.mouseEnabled = false;
			palMkrPhantom = new PaletteMarker();
			palMkrPhantom.mouseEnabled = false;
			palMkrPhantom.alpha = 0.3;
			
			paintArea.visible = false;
			
			squarePhantom = new Square();
			squarePhantom.alpha = 0.4;
			squarePhantom.x = squarePhantom.y = Constants.SQUAREPOS;
			
			hider = new Sprite();
			hider.visible=false;
			addChild(hider);
			
			progressBar.fill.mask = progressBar.masker;
			
			addEventListener(MouseEvent.MOUSE_OVER, evMouseOver, false,0,true);
			addEventListener(MouseEvent.MOUSE_OUT, evMouseOut, false,0,true);
			addEventListener(MouseEvent.MOUSE_DOWN, evMouseDown, false,0,true);
			addEventListener(MouseEvent.CLICK, evClick, false,0,true);
			
			canvas = new Canvas(1,1);
			addChild(canvas);
			
			generateParts();
			nextCanvas();
			
			//don't go over 40 or so in either dimension
			//makeCanvas(20,1);
			
			addChild(new FrontScreen());
		}
		
		private function set currColor($col:uint):void
		{
			col = $col;
			squarePhantom.col = $col;
		}
		private function get currColor():uint {return col;}
		
		private function canvasDone():void
		{
			if(!Constants.DEBUGMODE) canvas.trim();
			if(currBodyPart.type=="body"){
				bodyScaleX = canvas.dimX/body.wd;
				bodyScaleY = canvas.dimY/body.ht;	
			}
			currBodyPart.wd = canvas.dimX;
			currBodyPart.ht = canvas.dimY;
			
			currBodyPart.canvasData = canvas.pixToString();
			//trace("canvasData:",currBodyPart.canvasData);
			
			tweetSound.play();
			
			nextCanvas();
		}
		
		private function nextCanvas():void
		{
			if(allBodyParts.length>0){
				progressBar.masker.scaleX = (totBodyParts-allBodyParts.length)/totBodyParts;
				
				var randChoice:uint = Math.floor(Math.random()*allBodyParts.length);
				currBodyPart = allBodyParts[randChoice];
				setHeadline(currBodyPart.type);
				makeCanvas(currBodyPart.wd, currBodyPart.ht, -10+Math.random()*20);
				allBodyParts.splice(randChoice,1);
				
				/*
				hintContainer.addChild(hintContainer.area);
				switch(currBodyPart.type){
					case "head": hintContainer.addChild(hintContainer.hintHead); break;
					case "body": hintContainer.addChild(hintContainer.hintBody); break;
					case "leg": hintContainer.addChild(hintContainer.hintLeg); break;
					case "arm": hintContainer.addChild(hintContainer.hintArm); break;
				}
				*/
			}
			else showAnimal();
		}
		
		private function showAnimal():void
		{
			var animal:Sprite = new Sprite();
			//animal.x = animal.y = 100;
			//animal.scaleX = animal.scaleY = 0.1;
			//addChild(animal);
			
			var bodySprite = new PixelGrid(body.canvasData);
			animal.addChild(bodySprite);
			
			var headSprite = new PixelGrid(head.canvasData);
			headSprite.x = Constants.PIXDIM*head.pos*bodyScaleX;
			headSprite.y = -Constants.PIXDIM*head.ht;
			headSprite.rotation = head.rot;
			animal.addChild(headSprite);
			
			var obj:Object;
			for each(obj in armsLeft){
				var tempArmL = new PixelGrid(obj.canvasData);
				tempArmL.scaleX = -1;
				tempArmL.x = 0;
				tempArmL.y = Constants.PIXDIM*obj.pos*bodyScaleY;
				tempArmL.rotation = -obj.rot;
				animal.addChild(tempArmL);
			}
			for each(obj in armsRight){
				var tempArmR = new PixelGrid(obj.canvasData);
				tempArmR.x = Constants.PIXDIM*body.wd;
				tempArmR.y = Constants.PIXDIM*obj.pos*bodyScaleY;
				tempArmR.rotation = obj.rot;
				animal.addChild(tempArmR);
			}
			for each(obj in legs){
				var tempLeg = new PixelGrid(obj.canvasData);
				tempLeg.x = Constants.PIXDIM*obj.pos*bodyScaleX;
				tempLeg.y = Constants.PIXDIM*body.ht;
				tempLeg.rotation = obj.rot;
				animal.addChild(tempLeg);
			}				
			
			currPopup = new CryptidScreen();
			currPopup.hello.text = randStr(Constants.HELLOS);
			if(!Constants.DEBUGMODE) currPopup.cryptidArea.visible = false;
			addChild(currPopup);						
			addChild(new CryptidPreScreen());
			
			mainSongChannel.stop();
			cryptidRevealChannel = cryptidRevealSound.play(0,int.MAX_VALUE);
			
					
			//var animalXFrac:Number = currPopup.cryptidArea.width/animal.width;
			//var animalYFrac:Number = currPopup.cryptidArea.height/animal.height;	
			//animal.scaleX = animal.scaleY = (animalXFrac<animalYFrac? animalXFrac : animalYFrac);			
			//animal.x = currPopup.cryptidArea.x;
			//animal.y = currPopup.cryptidArea.y;			
			//animal.x = currPopup.cryptidArea.x + (currPopup.cryptidArea.width - animal.width)/2;
			//animal.y = currPopup.cryptidArea.y + (currPopup.cryptidArea.height - animal.height)/2;
			
			//animal.scaleX = animal.scaleY = 0.14;
			if(animal.height>0)	animal.scaleX = animal.scaleY = 176/animal.height;
			animal.x = 250;
			animal.y = 190;
			
			currPopup.addChild(animal);
			
			currPopup.btnRestart.addEventListener(MouseEvent.CLICK, onRestartClicked, false,0,true);
		}
		
		private function onRestartClicked(ev:MouseEvent=null):void
		{
			removeChild(currPopup);
			currPopup=null;
			
			cryptidRevealChannel.stop();
			mainSongChannel = mainSongSound.play(0,int.MAX_VALUE);
			
			generateParts();
			nextCanvas();
		}
		
		private function setHeadline($type:String):void
		{
			if($type=="head"){
				headline.text = randStr(Constants.HEADLINES_HEAD);
				//headline.text = "Draw a head.";
			}
			else if($type=="body"){
				headline.text = randStr(Constants.HEADLINES_BODY);
				//headline.text = "Draw a body.";
			}
			else if($type=="leg"){
				headline.text = randStr(Constants.HEADLINES_LEG);
				//headline.text = "Draw a leg.";
			}
			else if($type=="arm"){
				headline.text = randStr(Constants.HEADLINES_ARM);
				//headline.text = "Draw an arm.";
			}
		}
		
		private function randStr($arr:Array):String
		{
			return $arr[Math.floor(Math.random()*$arr.length)];
		}
		
		private function makeCanvas($x:uint,$y:uint, $rot:Number=0):void
		{
			removeChild(canvas);
			canvas = new Canvas($x,$y);
			canvas.rotation=$rot;
			
			var canvasXFrac:Number = paintArea.width/canvas.width;
			var canvasYFrac:Number = paintArea.height/canvas.height;	
			canvas.scaleX = canvas.scaleY = (canvasXFrac<canvasYFrac? canvasXFrac : canvasYFrac);
			canvas.x = paintArea.x;
			canvas.y = paintArea.y;
			
			addChild(canvas);
			
			palette.p1.dispatchEvent(new MouseEvent(MouseEvent.CLICK));
		}
		
		private function loadCanvas($str:String):void
		{
			var stArr:Array = $str.split("#");
			removeChild(canvas);
			canvas = null;
			makeCanvas(stArr[0], stArr[1]);
			canvas.loadStr(stArr[2]);
		}
		
		private function generateParts():void
		{
			armsLeft = [];
			armsRight = [];		
			legs = [];
			head = {};
			body = {};
				
			body.wd = 20 + Math.floor(Math.random()*21);
			body.ht = 20 + Math.floor(Math.random()*21);
			body.type = "body";
			//body.rot = -20 + Math.floor(Math.random()*41);
			
			head.wd = 10 + Math.floor(Math.random()*(body.wd-12));
			head.ht = 10 + Math.floor(Math.random()*(body.wd-12));
			head.pos = Math.floor(-head.wd/2 + Math.random()*(body.wd)+1);
			head.rot = -15 + Math.floor(Math.random()*31);
			head.type = "head";
			
			createArmsArray(armsLeft);
			createArmsArray(armsRight);
			createLegsArray();
			
			allBodyParts = new Array(head,body);
			allBodyParts = allBodyParts.concat(legs, armsLeft, armsRight);
			totBodyParts = allBodyParts.length;
			
			//testAnimal();
			
			function createArmsArray($arr:Array):void
			{
				var numArms:uint = Math.floor(Math.random()*3);
				
				var totHt:uint = 0;
				for(var iA:uint=0; iA<numArms; iA++){
				$arr[iA] = {};
				$arr[iA].ht = 3 + Math.floor(Math.random()*7);
				$arr[iA].wd = 10 + Math.floor(Math.random()*14);
				$arr[iA].rot = -20 + Math.floor(Math.random()*41);
				$arr[iA].type = "arm";
				totHt += $arr[iA].ht;
				}
				
				while(totHt > body.ht){
					totHt -= $arr.pop().ht;
					numArms--;
				}
				
				$arr.sort(sortArms);
				
				function sortArms(armA:Object, armB:Object):Number
				{
					if($arr == armsRight){
						if(armA.rot > armB.rot) return -1;
						return 1;
					}
					else{
						if(armA.rot < armB.rot) return -1;
						return 1;
					}
				}
				
				var totSpace:int = body.ht - totHt;
				var spaces:Array = [];
				var totRand:Number = 0;
				for(var iSpace:uint=0; iSpace<(numArms+1); iSpace++){
					spaces[iSpace] = Math.random();
					totRand += spaces[iSpace];
				}
				//convert random numbers to real space uints
				for(var iSp:uint=0; iSp<(numArms+1); iSp++){
					spaces[iSp] = Math.floor(spaces[iSp]/totRand*totSpace);
				}
				
				var startAt:uint = 0;
				for(var iAA:uint=0; iAA<numArms; iAA++){
					$arr[iAA].pos = startAt + spaces[iAA];
					startAt = $arr[iAA].pos + $arr[iAA].ht;
				}
			}
			
			function createLegsArray():void
			{
				var numLegs:uint = Math.floor(Math.random()*5);
				//trace("numLegs:",numLegs);
				
				var totWd:uint = 0;
				var iL:uint;
				for(iL=0; iL<numLegs; iL++){
				legs[iL] = {};
				legs[iL].wd = 3 + Math.floor(Math.random()*7);
				legs[iL].ht = 6 + Math.floor(Math.random()*20);
				legs[iL].rot = -20 + Math.floor(Math.random()*41);
				legs[iL].type = "leg";
				totWd += legs[iL].wd;
				}
				
				while(totWd > body.wd){
					totWd -= legs.pop().wd;
					numLegs--;
				}
				
				legs.sort(sortLegs);
				
				function sortLegs(legA:Object, legB:Object):Number
				{
					//trace("legA:",legA,"legB:",legB);
					if(legA.rot > legB.rot) return -1;
					return 1;
				}
				
				var totSpace:int = body.wd - totWd;
				var spaces:Array = [];
				var totRand:Number = 0;
				var iSpace:uint;
				for(iSpace=0; iSpace<(numLegs+1); iSpace++){
					spaces[iSpace] = Math.random();
					totRand += spaces[iSpace];
				}
				//convert random numbers to real space uints
				for(iSpace=0; iSpace<(numLegs+1); iSpace++){
					spaces[iSpace] = Math.floor(spaces[iSpace]/totRand*totSpace);
				}
				
				var startAt:uint = 0;
				for(iL=0; iL<numLegs; iL++){
					legs[iL].pos = startAt + spaces[iL];
					startAt = legs[iL].pos + legs[iL].wd;
				}
			}
			//trace("armsLeft",armsLeft);
			//trace("armsRight",armsRight);
			//trace("legs",legs);
		}
		
		/*
		//for testing only
		private function testAnimal():void
		{
			var animal:Sprite = new Sprite();
			animal.x = animal.y = 100;
			animal.scaleX = animal.scaleY = 0.1;
			addChild(animal);
			var pixSize:Number = 20;
			
			var bodySprite = new Square(1);
			bodySprite.scaleX = body.wd;
			bodySprite.scaleY = body.ht;
			animal.addChild(bodySprite);
			
			var headSprite = new Square(1);
			headSprite.scaleX = head.wd;
			headSprite.scaleY = head.ht;
			headSprite.x = 20*head.pos;
			headSprite.y = -20*head.ht;
			headSprite.rotation = head.rot;
			animal.addChild(headSprite);
			
			var obj:Object;
			
			for each(obj in armsLeft){
				var tempArmL = new Square(1);
				tempArmL.scaleX = -obj.wd;
				tempArmL.scaleY = obj.ht;
				tempArmL.x = 0;
				tempArmL.y = 20*obj.pos;
				tempArmL.rotation = -obj.rot;
				animal.addChild(tempArmL);
			}
			for each(obj in armsRight){
				var tempArmR = new Square(Constants.COL2);
				tempArmR.scaleX = obj.wd;
				tempArmR.scaleY = obj.ht;
				tempArmR.x = 20*body.wd;
				tempArmR.y = 20*obj.pos;
				tempArmR.rotation = obj.rot;
				animal.addChild(tempArmR);
			}
			for each(obj in legs){
				var tempLeg = new Square(0);
				tempLeg.scaleX = obj.wd;
				tempLeg.scaleY = obj.ht;
				tempLeg.x = 20*obj.pos;
				tempLeg.y = 20*body.ht;
				tempLeg.rotation = obj.rot;
				animal.addChild(tempLeg);
			}
			
			
		}
		*/
		
		private function evMouseOver(ev:MouseEvent):void
		{
			if(ev.target.parent is Palette){
				ev.target.addChild(palMkrPhantom);
				//palMkrPhantom.visible = true;
			}
			
			else{
				var pix:EmptyPixel = ev.target as EmptyPixel;
				if(pix){
					if(ev.buttonDown) pix.col = currColor;
					else{
						//squarePhantom.visible = true;
						pix.addChild(squarePhantom);
					}
				}
			}
		}
		
		private function evMouseDown(ev:MouseEvent):void
		{
			if(ev.target.parent is Palette){
				//ev.target.addChild(palMkrPhantom);
				//palMkrPhantom.visible = true;
			}
			
			else{
				var pix:EmptyPixel = ev.target as EmptyPixel;
				if(pix){
					pix.col = currColor;
					hider.addChild(squarePhantom);
				}
			}
		}
		
		private function evMouseOut(ev:MouseEvent):void
		{
			if(ev.target.parent is Palette){
				//palMkrPhantom.visible = false;
				hider.addChild(palMkrPhantom);
			}
			
			else{
				if(ev.target is EmptyPixel){
					//squarePhantom.visible = false;
					hider.addChild(squarePhantom);
				}
			}
			
		}
		
		private function evClick(ev:MouseEvent):void
		{
			var parpal:Palette = ev.target.parent as Palette;
			if(parpal){
				var tgt:MovieClip = ev.target as MovieClip;
				tgt.addChild(palMkr);
				
				if(tgt==parpal.p1) currColor = Constants.COL1;
				else if(tgt==parpal.p2) currColor = Constants.COL2;
				else if(tgt==parpal.p3) currColor = Constants.COL3;
				else if(tgt==parpal.p4) currColor = Constants.COL4;
				else if(tgt==parpal.p5) currColor = Constants.COL5;
				else if(tgt==parpal.p6) currColor = Constants.COL6;
				else if(tgt==parpal.p7) currColor = Constants.COL7;
				else if(tgt==parpal.p8) currColor = Constants.COL8;
			}
			else{
				var pix:EmptyPixel = ev.target as EmptyPixel;
				if(pix) {}
				else if(ev.target==btnOK){
					//trace(saveCanvas());
					//loadCanvas("4#4#2424363624243636");
					canvasDone();
				}
			}
		}
		
	}
}